# -*- coding: utf-8 -*-
# Generated by Django 1.11.29 on 2021-04-08 11:24
from __future__ import unicode_literals

import datetime
import django.contrib.postgres.fields.jsonb
from django.db import migrations, models
import django.db.models.deletion
import django.utils.timezone


class Migration(migrations.Migration):

    initial = True

    dependencies = [
    ]

    operations = [
        migrations.CreateModel(
            name='Deployment',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=100)),
                ('reference', models.SlugField()),
                ('description', models.TextField(blank=True)),
                ('notes', models.TextField(blank=True)),
                ('creation_datetime', models.DateTimeField(default=datetime.datetime.now)),
                ('active', models.BooleanField(default=False)),
                ('deleted', models.BooleanField(default=False)),
                ('priority', models.IntegerField(blank=True, default=0)),
                ('begin_run_date', models.DateField(blank=True, null=True)),
                ('end_run_date', models.DateField(blank=True, null=True)),
                ('last_run_date', models.DateField(blank=True, null=True)),
                ('begin_date', models.DateField(blank=True, null=True)),
                ('end_date', models.DateField(blank=True, null=True)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='DeploymentBoundary',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=100)),
                ('reference', models.SlugField()),
                ('deployment', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='datamodel.Deployment')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='DeploymentFile',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=100)),
                ('reference', models.SlugField()),
                ('file', models.BinaryField()),
                ('deployment', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='files', to='datamodel.Deployment')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='DeploymentForcing',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('priority', models.IntegerField(blank=True, default=0)),
                ('deployment_boundary', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='datamodel.DeploymentBoundary')),
            ],
        ),
        migrations.CreateModel(
            name='DeploymentOutputFilepath',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('date', models.DateField(default=datetime.date.today)),
                ('filepath', models.FilePathField(match='(?:\\d{,2}_[0-9a-zA-Z_-]+\\.(?:61|64|nc|xz)|(?:logs|confs|forcings)\\.tar\\.xz)', max_length=254, path='/_data/runs', recursive=True)),
                ('deployment', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='datamodel.Deployment')),
            ],
        ),
        migrations.CreateModel(
            name='DeploymentParameter',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('value', models.TextField(blank=True)),
                ('notes', models.TextField(blank=True)),
                ('deployment', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='datamodel.Deployment')),
            ],
        ),
        migrations.CreateModel(
            name='DeploymentRun',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('run_datetime', models.DateTimeField()),
                ('state', models.CharField(choices=[('pending', 'Pending'), ('started', 'Started'), ('finished', 'Finished'), ('failed', 'Failed')], max_length=8)),
                ('begin', models.DateTimeField(default=django.utils.timezone.now, null=True)),
                ('end', models.DateTimeField(blank=True, null=True)),
                ('deployment', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='datamodel.Deployment')),
            ],
        ),
        migrations.CreateModel(
            name='DeploymentRunMessage',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('kind', models.CharField(choices=[('error', 'Error'), ('timings', 'Timings')], max_length=8)),
                ('message', models.TextField(blank=True)),
                ('deployment_run', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='datamodel.DeploymentRun')),
            ],
        ),
        migrations.CreateModel(
            name='DeploymentRunOutputFilepath',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('kind', models.CharField(choices=[('logs', 'Logs'), ('confs', 'Configurations'), ('inputs', 'Inputs'), ('results', 'Results')], max_length=8)),
                ('filepath', models.FilePathField(match='^(?:\\d{,2}_[0-9a-zA-Z_-]+\\.(?:61|64|nc|xz)|(?:logs|confs|forcings)\\.tar\\.xz)$', max_length=254, path='/_data/runs', recursive=True)),
                ('deployment_run', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='datamodel.DeploymentRun')),
            ],
        ),
        migrations.CreateModel(
            name='FileType',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=100)),
                ('reference', models.SlugField()),
                ('description', models.TextField(blank=True)),
                ('notes', models.TextField(blank=True)),
                ('format', models.CharField(choices=[('gr3', 'GR3'), ('ll', 'LL'), ('netcdf', 'netCDF'), ('in', 'IN'), ('nml', 'NML')], default='gr3', max_length=10)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='ForcingSource',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=100)),
                ('reference', models.SlugField()),
                ('description', models.TextField(blank=True)),
                ('notes', models.TextField(blank=True)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='Model',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=100)),
                ('reference', models.SlugField()),
                ('description', models.TextField(blank=True)),
                ('notes', models.TextField(blank=True)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='ModelParameter',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('description', models.TextField(blank=True)),
                ('notes', models.TextField(blank=True)),
                ('default_value', models.TextField(blank=True)),
                ('model', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='datamodel.Model')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='ModelRequirement',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('description', models.TextField(blank=True)),
                ('notes', models.TextField(blank=True)),
                ('ruleset', django.contrib.postgres.fields.jsonb.JSONField(blank=True, null=True)),
                ('model', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='datamodel.Model')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='ModelVersion',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('version', models.CharField(max_length=50)),
                ('model', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='datamodel.Model')),
            ],
        ),
        migrations.CreateModel(
            name='ModelVersionParameter',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('description', models.TextField(blank=True)),
                ('notes', models.TextField(blank=True)),
                ('default_value', models.TextField(blank=True)),
                ('model_version', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='datamodel.ModelVersion')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='ModelVersionRequirement',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('description', models.TextField(blank=True)),
                ('notes', models.TextField(blank=True)),
                ('ruleset', django.contrib.postgres.fields.jsonb.JSONField(blank=True, null=True)),
                ('model_version', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='datamodel.ModelVersion')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='ModelVersionRunPeriod',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('run_period', models.IntegerField(choices=[(48, '48h'), (72, '72h')], default=48)),
                ('model_version', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='datamodel.ModelVersion')),
            ],
        ),
        migrations.CreateModel(
            name='Parameter',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=100)),
                ('reference', models.SlugField()),
                ('description', models.TextField(blank=True)),
                ('notes', models.TextField(blank=True)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='Requirement',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=100)),
                ('reference', models.SlugField()),
                ('description', models.TextField(blank=True)),
                ('notes', models.TextField(blank=True)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.AddField(
            model_name='modelversionrequirement',
            name='requirement',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='datamodel.Requirement'),
        ),
        migrations.AddField(
            model_name='modelversionparameter',
            name='parameter',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='datamodel.Parameter'),
        ),
        migrations.AddField(
            model_name='modelrequirement',
            name='requirement',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='datamodel.Requirement'),
        ),
        migrations.AddField(
            model_name='modelparameter',
            name='parameter',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='datamodel.Parameter'),
        ),
        migrations.AddField(
            model_name='deploymentparameter',
            name='parameter',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='datamodel.Parameter'),
        ),
        migrations.AddField(
            model_name='deploymentforcing',
            name='forcing_source',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='datamodel.ForcingSource'),
        ),
        migrations.AddField(
            model_name='deploymentfile',
            name='file_type',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='datamodel.FileType'),
        ),
        migrations.AddField(
            model_name='deployment',
            name='model_version_period',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='datamodel.ModelVersionRunPeriod'),
        ),
    ]
